#include "redeNeural.h"

	int maior, i, k;
        int f = 360/(NUM_FEIXES - 1);
        float entrada[36];
        float saida[7];	


int net10(float *in, float *out, int init){
  int member, source;
  float sum;
  enum{OK, Error, Not_Valid};
  pUnit unit;


  /* layer definition section (names & member units) */

  static pUnit Input[36] = {Units + 1, Units + 2, Units + 3, Units + 4, Units + 5, Units + 6, Units + 7, Units + 8, Units + 9, Units + 10, Units + 11, Units + 12, Units + 13, Units + 14, Units + 15, Units + 16, Units + 17, Units + 18, Units + 19, Units + 20, Units + 21, Units + 22, Units + 23, Units + 24, Units + 25, Units + 26, Units + 27, Units + 28, Units + 29, Units + 30, Units + 31, Units + 32, Units + 33, Units + 34, Units + 35, Units + 36}; /* members */

  static pUnit Hidden1[10] = {Units + 37, Units + 38, Units + 39, Units + 40, Units + 41, Units + 42, Units + 43, Units + 44, Units + 45, Units + 46}; /* members */

  static pUnit Output1[7] = {Units + 47, Units + 48, Units + 49, Units + 50, Units + 51, Units + 52, Units + 53}; /* members */

  static int Output[7] = {47, 48, 49, 50, 51, 52, 53};

  for(member = 0; member < 36; member++) {
    Input[member]->act = in[member];
  }

  for (member = 0; member < 10; member++) {
    unit = Hidden1[member];
    sum = 0.0;
    for (source = 0; source < unit->NoOfSources; source++) {
      sum += unit->sources[source]->act
             * unit->weights[source];
    }
    unit->act = Act_Logistic(sum, unit->Bias);
  };

  for (member = 0; member < 7; member++) {
    unit = Output1[member];
    sum = 0.0;
    for (source = 0; source < unit->NoOfSources; source++) {
      sum += unit->sources[source]->act
             * unit->weights[source];
    }
    unit->act = Act_Logistic(sum, unit->Bias);
  };

  for(member = 0; member < 7; member++) {
    out[member] = Units[Output[member]].act;
  }

  return(OK);
}

int localizarEstadoRN(playerc_client_t *client, playerc_laser_t *laser){

	
	playerc_client_read(client);
	
        for(i = 0; i < NUM_FEIXES; i++){
            entrada[i] = laser->scan[(i*f)][0];
        }

        net10(entrada, saida, 0);

        //descobrir em saida, qual eh o maior elemento

        maior = 0;
        for(i = 1; i < 7; i++){
            if(saida[i] > saida[maior]){
                maior = i;
            }
        }

    // 7 - beco sem saida
    //if(laser->scan[0][0] <= 1 && laser->scan[ANGULO-1][0] <= 1 && laser->scan[ANGULO/2][0] <= 0.5)
//	return 7;
	
    return maior;
}

