#define Act_Logistic(sum, bias)  ( (sum+bias<10000.0) ? ( 1.0/(1.0 + exp(-sum-bias) ) ) : 0.0 )
#ifndef NULL
#define NULL (void *)0
#endif

typedef struct UT {
          float act;         /* Activation       */
          float Bias;        /* Bias of the Unit */
          int   NoOfSources; /* Number of predecessor units */
   struct UT   **sources; /* predecessor units */
          float *weights; /* weights from predecessor units */
        } UnitType, *pUnit;

  /* Forward Declaration for all unit types */
  static UnitType Units[54];
  /* Sources definition section */
  static pUnit Sources[] =  {
Units + 1, Units + 2, Units + 3, Units + 4, Units + 5, Units + 6, Units + 7, Units + 8, Units + 9, Units + 10, 
Units + 11, Units + 12, Units + 13, Units + 14, Units + 15, Units + 16, Units + 17, Units + 18, Units + 19, Units + 20, 
Units + 21, Units + 22, Units + 23, Units + 24, Units + 25, Units + 26, Units + 27, Units + 28, Units + 29, Units + 30, 
Units + 31, Units + 32, Units + 33, Units + 34, Units + 35, Units + 36, 
Units + 1, Units + 2, Units + 3, Units + 4, Units + 5, Units + 6, Units + 7, Units + 8, Units + 9, Units + 10, 
Units + 11, Units + 12, Units + 13, Units + 14, Units + 15, Units + 16, Units + 17, Units + 18, Units + 19, Units + 20, 
Units + 21, Units + 22, Units + 23, Units + 24, Units + 25, Units + 26, Units + 27, Units + 28, Units + 29, Units + 30, 
Units + 31, Units + 32, Units + 33, Units + 34, Units + 35, Units + 36, 
Units + 1, Units + 2, Units + 3, Units + 4, Units + 5, Units + 6, Units + 7, Units + 8, Units + 9, Units + 10, 
Units + 11, Units + 12, Units + 13, Units + 14, Units + 15, Units + 16, Units + 17, Units + 18, Units + 19, Units + 20, 
Units + 21, Units + 22, Units + 23, Units + 24, Units + 25, Units + 26, Units + 27, Units + 28, Units + 29, Units + 30, 
Units + 31, Units + 32, Units + 33, Units + 34, Units + 35, Units + 36, 
Units + 1, Units + 2, Units + 3, Units + 4, Units + 5, Units + 6, Units + 7, Units + 8, Units + 9, Units + 10, 
Units + 11, Units + 12, Units + 13, Units + 14, Units + 15, Units + 16, Units + 17, Units + 18, Units + 19, Units + 20, 
Units + 21, Units + 22, Units + 23, Units + 24, Units + 25, Units + 26, Units + 27, Units + 28, Units + 29, Units + 30, 
Units + 31, Units + 32, Units + 33, Units + 34, Units + 35, Units + 36, 
Units + 1, Units + 2, Units + 3, Units + 4, Units + 5, Units + 6, Units + 7, Units + 8, Units + 9, Units + 10, 
Units + 11, Units + 12, Units + 13, Units + 14, Units + 15, Units + 16, Units + 17, Units + 18, Units + 19, Units + 20, 
Units + 21, Units + 22, Units + 23, Units + 24, Units + 25, Units + 26, Units + 27, Units + 28, Units + 29, Units + 30, 
Units + 31, Units + 32, Units + 33, Units + 34, Units + 35, Units + 36, 
Units + 1, Units + 2, Units + 3, Units + 4, Units + 5, Units + 6, Units + 7, Units + 8, Units + 9, Units + 10, 
Units + 11, Units + 12, Units + 13, Units + 14, Units + 15, Units + 16, Units + 17, Units + 18, Units + 19, Units + 20, 
Units + 21, Units + 22, Units + 23, Units + 24, Units + 25, Units + 26, Units + 27, Units + 28, Units + 29, Units + 30, 
Units + 31, Units + 32, Units + 33, Units + 34, Units + 35, Units + 36, 
Units + 1, Units + 2, Units + 3, Units + 4, Units + 5, Units + 6, Units + 7, Units + 8, Units + 9, Units + 10, 
Units + 11, Units + 12, Units + 13, Units + 14, Units + 15, Units + 16, Units + 17, Units + 18, Units + 19, Units + 20, 
Units + 21, Units + 22, Units + 23, Units + 24, Units + 25, Units + 26, Units + 27, Units + 28, Units + 29, Units + 30, 
Units + 31, Units + 32, Units + 33, Units + 34, Units + 35, Units + 36, 
Units + 1, Units + 2, Units + 3, Units + 4, Units + 5, Units + 6, Units + 7, Units + 8, Units + 9, Units + 10, 
Units + 11, Units + 12, Units + 13, Units + 14, Units + 15, Units + 16, Units + 17, Units + 18, Units + 19, Units + 20, 
Units + 21, Units + 22, Units + 23, Units + 24, Units + 25, Units + 26, Units + 27, Units + 28, Units + 29, Units + 30, 
Units + 31, Units + 32, Units + 33, Units + 34, Units + 35, Units + 36, 
Units + 1, Units + 2, Units + 3, Units + 4, Units + 5, Units + 6, Units + 7, Units + 8, Units + 9, Units + 10, 
Units + 11, Units + 12, Units + 13, Units + 14, Units + 15, Units + 16, Units + 17, Units + 18, Units + 19, Units + 20, 
Units + 21, Units + 22, Units + 23, Units + 24, Units + 25, Units + 26, Units + 27, Units + 28, Units + 29, Units + 30, 
Units + 31, Units + 32, Units + 33, Units + 34, Units + 35, Units + 36, 
Units + 1, Units + 2, Units + 3, Units + 4, Units + 5, Units + 6, Units + 7, Units + 8, Units + 9, Units + 10, 
Units + 11, Units + 12, Units + 13, Units + 14, Units + 15, Units + 16, Units + 17, Units + 18, Units + 19, Units + 20, 
Units + 21, Units + 22, Units + 23, Units + 24, Units + 25, Units + 26, Units + 27, Units + 28, Units + 29, Units + 30, 
Units + 31, Units + 32, Units + 33, Units + 34, Units + 35, Units + 36, 
Units + 37, Units + 38, Units + 39, Units + 40, Units + 41, Units + 42, Units + 43, Units + 44, Units + 45, Units + 46, 

Units + 37, Units + 38, Units + 39, Units + 40, Units + 41, Units + 42, Units + 43, Units + 44, Units + 45, Units + 46, 

Units + 37, Units + 38, Units + 39, Units + 40, Units + 41, Units + 42, Units + 43, Units + 44, Units + 45, Units + 46, 

Units + 37, Units + 38, Units + 39, Units + 40, Units + 41, Units + 42, Units + 43, Units + 44, Units + 45, Units + 46, 

Units + 37, Units + 38, Units + 39, Units + 40, Units + 41, Units + 42, Units + 43, Units + 44, Units + 45, Units + 46, 

Units + 37, Units + 38, Units + 39, Units + 40, Units + 41, Units + 42, Units + 43, Units + 44, Units + 45, Units + 46, 

Units + 37, Units + 38, Units + 39, Units + 40, Units + 41, Units + 42, Units + 43, Units + 44, Units + 45, Units + 46, 


  };

  /* Weigths definition section */
  static float Weights[] =  {
0.188640, 0.122390, -0.246070, 0.487940, -0.386440, -0.151580, -0.637600, 0.293560, 0.644460, 0.402240, 
1.140060, -0.281440, -0.903760, -0.347440, -1.201890, -0.089980, -0.054330, 0.323580, 0.298050, 0.920720, 
-0.399750, 0.900020, 0.294990, 1.381160, -0.516000, -0.339410, -0.463780, -0.560680, -0.594850, -0.071990, 
-0.559650, -0.196390, -0.183590, -0.773460, -0.758710, -1.458080, 
-0.182560, -0.255780, 0.108550, 0.158860, -0.257550, -0.100660, -1.797950, -0.048870, -0.044730, 0.423130, 
0.267980, 0.218610, 0.239930, 0.156670, -0.075130, 0.017970, 0.183560, -0.272890, 0.550930, 0.550290, 
0.381480, 0.186040, -0.704890, -0.006730, -0.269010, -0.299620, 0.061530, 0.769850, 2.224250, 0.162230, 
0.742910, -0.471130, 0.158830, 0.300220, 0.098780, -0.380180, 
0.330040, 0.309640, 0.046670, -0.095220, -0.101050, 0.095660, 0.344550, 0.453920, 0.599030, 0.200370, 
-0.020200, -0.842050, -0.525680, -0.574590, -1.204180, -0.031110, -0.174110, -0.091640, 0.101680, -0.010610, 
0.014750, 0.031420, 0.284090, 0.894080, 3.730540, -0.024390, 0.183180, 0.729540, -0.002740, 0.323270, 
-0.085250, -0.030210, 0.028120, 0.303650, 0.044630, 0.166910, 
1.152180, 0.509240, 0.069150, -0.193800, 0.506350, 0.586180, 0.819930, 0.908740, 0.081460, 0.261660, 
-0.667630, -0.226310, -0.241960, 0.072820, 1.183980, 0.444450, 0.465530, -0.505230, 0.163070, 0.076810, 
0.398980, -0.269660, -0.295430, 0.235870, 1.750660, -0.598910, 0.281900, -1.035290, -2.103040, -0.974660, 
0.179790, -0.140560, 0.174980, -0.273040, -0.076760, -0.390610, 
-1.049040, -0.085060, -0.537690, -0.670500, -0.229390, 0.193270, -0.643350, -0.791290, -5.455570, -1.385840, 
0.073800, -0.015440, 1.042900, 1.834590, 0.800280, 0.619020, 0.925230, 0.065150, -0.202240, 1.033450, 
1.466830, -0.028960, 0.971720, -0.083330, -0.331420, 0.715730, -0.502930, 1.009720, 0.810120, -0.159390, 
-0.733990, 0.595290, 0.294170, 0.138640, -0.397990, 0.419650, 
-0.205670, 0.027490, 0.219460, -0.107310, 0.165730, 0.081150, 0.595120, 0.304890, -0.163780, 0.232820, 
0.098820, -0.446610, -0.083410, -0.682010, -0.645630, -0.082350, -0.629150, -0.380630, -0.193220, -0.715270, 
-0.144620, 0.464700, -0.569680, -0.100170, -0.148460, 0.180550, 0.101280, -0.037930, 0.865220, 0.745370, 
0.050770, -0.064900, 0.182530, -0.016280, 0.116590, -0.067860, 
-1.899630, -0.111030, -0.513090, -0.639160, -1.292830, -0.219050, -0.086540, -3.129790, 0.404130, 0.108850, 
-1.979170, -1.939880, 0.639440, 1.767170, 0.060080, 1.527150, 0.000770, -0.389340, 0.997740, 0.694630, 
-0.455160, -0.403980, 1.671930, 0.049550, 0.436490, -0.895770, -0.196980, -0.218740, 0.359240, 0.346510, 
-1.485110, 0.078640, 0.744670, -0.469200, -0.036710, -0.045200, 
-1.560810, -0.767590, 0.489000, -0.896330, -0.040530, 0.073570, -0.334250, -0.413030, -0.580250, 0.197380, 
0.697420, -0.640030, 0.647500, -0.449210, 0.363990, -0.063840, 0.177910, -0.253730, 0.225620, 0.156020, 
-0.598740, 0.392280, 0.922850, 0.157280, -0.548950, -0.733390, 0.083360, -0.943650, -0.060000, -0.485650, 
-0.437550, -0.208330, -0.526290, 0.723270, -0.612340, -0.124910, 
-0.568070, 0.648370, 0.573040, 0.217510, 0.000790, -0.697800, 0.243820, 0.398850, 0.288060, 0.415890, 
0.885950, -0.514480, 0.571920, 0.918290, -0.214270, 0.845330, 0.005930, -0.035950, -0.285960, -0.041050, 
0.775650, 0.868330, 0.696760, -0.328010, 0.686970, 0.214430, -0.178420, -1.019810, -1.611160, -1.312910, 
0.676720, -1.477020, -1.047200, -0.283570, -1.344930, -1.474990, 
-0.104560, 0.135120, 0.088470, -0.065620, 0.048400, 0.148480, 0.150290, -0.503670, 0.069290, -0.380230, 
-1.014830, 0.015870, -0.084690, -0.137440, 0.099620, -0.053930, -0.462500, -0.092180, 0.675360, 0.534350, 
0.141100, 0.462470, 0.353260, 0.315580, 2.098240, 0.356590, -0.274670, -0.995920, -0.678580, -1.004810, 
-0.155540, -0.510020, 0.073920, -0.229870, -0.334070, -0.378520, 
1.990820, -9.999370, 6.166490, -1.829130, -3.147880, -2.469830, -5.264570, 8.867710, 3.428860, -6.549490, 

5.579570, 2.516840, -12.081080, -1.433440, 1.961700, -0.968280, -6.926250, -6.060490, 5.226470, 5.784490, 

-13.771900, -4.635220, 8.942710, 5.230090, 2.930170, -11.650940, -10.343070, -5.210080, -5.165220, 4.141810, 

9.471020, -2.921250, -8.958210, -0.415820, 1.000400, 0.290420, 7.337970, 5.784470, -1.746730, -0.722610, 

-1.165810, 8.929010, 0.766680, -0.516050, -12.933160, 6.882320, -0.142870, -2.012720, -2.558050, -2.086910, 

-9.052530, -3.840000, 3.552950, -9.134170, 0.818530, -3.251010, 10.098170, -6.306210, 7.044020, 4.678040, 

0.192950, -2.439770, -4.356600, -4.353440, 10.569600, 9.769970, -3.577010, -0.514000, -1.919130, -7.208240, 


  };

  /* unit definition section (see also UnitType) */
  static UnitType Units[54] = 
  {
    { 0.0, 0.0, 0, NULL , NULL },
    { /* unit 1 (noName) */
      0.0, 0.843010, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 2 (noName) */
      0.0, -0.164710, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 3 (noName) */
      0.0, -0.428750, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 4 (noName) */
      0.0, 0.145240, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 5 (noName) */
      0.0, 0.315040, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 6 (noName) */
      0.0, -0.581410, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 7 (noName) */
      0.0, 0.404830, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 8 (noName) */
      0.0, 0.148230, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 9 (noName) */
      0.0, -0.966370, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 10 (noName) */
      0.0, 0.365460, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 11 (noName) */
      0.0, 0.400920, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 12 (noName) */
      0.0, -0.783680, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 13 (noName) */
      0.0, -0.039030, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 14 (noName) */
      0.0, -0.713860, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 15 (noName) */
      0.0, 0.237530, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 16 (noName) */
      0.0, 0.789360, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 17 (noName) */
      0.0, -0.643240, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 18 (noName) */
      0.0, 0.664540, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 19 (noName) */
      0.0, -0.324810, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 20 (noName) */
      0.0, 0.949830, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 21 (noName) */
      0.0, -0.119240, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 22 (noName) */
      0.0, 0.799370, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 23 (noName) */
      0.0, -0.017730, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 24 (noName) */
      0.0, 0.397630, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 25 (noName) */
      0.0, 0.918390, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 26 (noName) */
      0.0, 0.078460, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 27 (noName) */
      0.0, -0.636280, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 28 (noName) */
      0.0, -0.586600, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 29 (noName) */
      0.0, -0.058810, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 30 (noName) */
      0.0, 0.146580, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 31 (noName) */
      0.0, -0.293500, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 32 (noName) */
      0.0, 0.872490, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 33 (noName) */
      0.0, -0.284710, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 34 (noName) */
      0.0, -0.469220, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 35 (noName) */
      0.0, -0.046110, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 36 (noName) */
      0.0, -0.628350, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 37 (noName) */
      0.0, 1.355030, 36,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 38 (noName) */
      0.0, -2.472370, 36,
       &Sources[36] , 
       &Weights[36] , 
      },
    { /* unit 39 (noName) */
      0.0, 0.042740, 36,
       &Sources[72] , 
       &Weights[72] , 
      },
    { /* unit 40 (noName) */
      0.0, -1.537820, 36,
       &Sources[108] , 
       &Weights[108] , 
      },
    { /* unit 41 (noName) */
      0.0, 0.659810, 36,
       &Sources[144] , 
       &Weights[144] , 
      },
    { /* unit 42 (noName) */
      0.0, 4.098280, 36,
       &Sources[180] , 
       &Weights[180] , 
      },
    { /* unit 43 (noName) */
      0.0, 1.214200, 36,
       &Sources[216] , 
       &Weights[216] , 
      },
    { /* unit 44 (noName) */
      0.0, 8.325500, 36,
       &Sources[252] , 
       &Weights[252] , 
      },
    { /* unit 45 (noName) */
      0.0, 0.689890, 36,
       &Sources[288] , 
       &Weights[288] , 
      },
    { /* unit 46 (noName) */
      0.0, -2.399900, 36,
       &Sources[324] , 
       &Weights[324] , 
      },
    { /* unit 47 (noName) */
      0.0, 0.321080, 10,
       &Sources[360] , 
       &Weights[360] , 
      },
    { /* unit 48 (noName) */
      0.0, -1.214850, 10,
       &Sources[370] , 
       &Weights[370] , 
      },
    { /* unit 49 (noName) */
      0.0, -3.255430, 10,
       &Sources[380] , 
       &Weights[380] , 
      },
    { /* unit 50 (noName) */
      0.0, -3.188130, 10,
       &Sources[390] , 
       &Weights[390] , 
      },
    { /* unit 51 (noName) */
      0.0, -9.616470, 10,
       &Sources[400] , 
       &Weights[400] , 
      },
    { /* unit 52 (noName) */
      0.0, -4.058780, 10,
       &Sources[410] , 
       &Weights[410] , 
      },
    { /* unit 53 (noName) */
      0.0, -7.631510, 10,
       &Sources[420] , 
       &Weights[420] , 
      }

  };

//dado um vetor de entrada, retorna um vetor com as saídas da rede neural
int net10(float *in, float *out, int init);

//dado um vetor de entrada, verifica a saída da rede com maior valor (estado)
int localizarEstadoRN(playerc_client_t *client, playerc_laser_t *laser);
