#ifndef NAVEGA_H
#define NAVEGA_H

#include <stdlib.h>
#include <math.h>

#include <libplayerc/playerc.h>

#define NUM_FEIXES 36
#define NUM_EXAMPLES 150
#define ANGULO 360
#define NUM_VERTICES 17

#define OBJETIVOX 29
#define OBJETIVOY 17

playerc_client_t *client;
playerc_position2d_t *position2d;
playerc_laser_t *laser;

void atualizaLeitura(playerc_client_t *client);

void alinharCorredor(playerc_client_t *client, playerc_position2d_t *position2d, playerc_laser_t *laser);

void cruzar(playerc_client_t *client, playerc_position2d_t *position2d, playerc_laser_t *laser, int proxEstado);

int ehObjetivo(playerc_client_t *client, playerc_position2d_t *position2d);

void posicionaCurva(playerc_client_t *client, playerc_position2d_t *position2d, playerc_laser_t *laser, int dir);

void virarEsquerda(playerc_client_t *client, playerc_position2d_t *position2d, playerc_laser_t *laser, int proxEstado);

void virarDireita(playerc_client_t *client, playerc_position2d_t *position2d, playerc_laser_t *laser, int proxEstado);

void darMeiaVolta(playerc_client_t *client, playerc_laser_t *laser, playerc_position2d_t *position2d, int acao, int proxEstado);

int navega(int acoes[], int tam);

#endif
