#include "navega.h"
#include "redeNeural.c"

#define NUM_REPETICOES 1

int conexao(){
	int i;

	//conecta ao player e ativa o laser
	system("gnome-terminal -e \"player ambiente.cfg\"");
	sleep(4);
	// Create a client and connect it to the server.
	client = playerc_client_create(NULL, "localhost", 6665);

	if (0 != playerc_client_connect(client))
		return -1;

	// Connect to Position
	position2d = playerc_position2d_create(client, 0);
	if (playerc_position2d_subscribe(position2d, PLAYERC_OPEN_MODE) != 0){
		fprintf(stderr, "error: %s\n", playerc_error_str());
		return -1;
	}
	// Connect to Laser
	laser = playerc_laser_create(client, 0);
	if (playerc_laser_subscribe(laser, PLAYERC_OPEN_MODE))
		return -1;

	for (i = 0; i < 10; i++){
		playerc_client_read(client);
	}
}

int possivelEstado(int estado, int acao){
	switch (acao){
	case 0: { //acao cruzar
		if (estado == 2) return 1;
		if (estado == 5) return 1;
		if (estado == 1) return 1;
		} break;
	case 1: { //acao esquerda
		if (estado == 6) return 1;
		if (estado == 5) return 1;
		if (estado == 2) return 1;
		} break;
	case 2: { //acao direita
		if (estado == 0) return 1;
		if (estado == 1) return 1;
		if (estado == 2) return 1;
		} break;
	case 3: { //meia volta

		} break;
	case 4: { //corredor
		if (estado == 3) return 1;
		} break;
	}
	return 0;
}

int ehObjetivo(playerc_client_t *client, playerc_position2d_t *position2d){
	playerc_client_read(client);
	if(position2d->px > (OBJETIVOX-3) && position2d->px < (OBJETIVOX+3)){
           if(position2d->py > (OBJETIVOY-3) && position2d->py < (OBJETIVOX+3))
		return 1;
	}
	return 0;
}

int navega(int acoes[], int tam){
	int i, j, c, estAtual;
	int first, estados[] = {3, 3, 5, 3, 0, 3, 0, 3, 1, 6, 3, 6, 3, 1, 3, 4, 3, 1, 3, 5, 3, 0, 3, 2, 6, 3, 1, 3};
	float esq, dir;

	printf("acoes: ");
	for(i = 0; i < tam; i++)
	    printf("%d, ", acoes[i]);

	conexao();
	estAtual = localizarEstadoRN(client, laser);
	printf("estado: %d\n", estAtual);

	i = 0; //contador ações
 	c = 0; //contador mudança de estados

	while(ehObjetivo(client, position2d) == 0){
	    estAtual = localizarEstadoRN(client, laser);
		if (possivelEstado(estAtual, acoes[i + 1]) == 1){
			c++;
		}else{
			c = 0;
		}
		if (c >= NUM_REPETICOES){
			i++;
			first = 1;
			printf("detected State: %d\n", estados[i]);
		}
		//printf("estadoDetectado: %d\n", estAtual);
		printf("action: %d\n", acoes[i]);
		switch (acoes[i]){
		case 0: { //cruzar
			//printf("cruzar\n");
			playerc_client_read(client);

			esq = laser->scan[359][0];
			dir = laser->scan[1][0];

			switch (estados[i]){
				case 1: { //frente e direita
					if (first == 1){
						if(dir <= 2*esq)
						while (laser->scan[10][0] < 1.3*dir){
							if (laser->scan[20][0] > laser->scan[10][0]){
								if (laser->scan[10][0] > dir)
									playerc_position2d_set_cmd_vel(position2d, 0.1, 0, -0.1, 1);
								else
									playerc_position2d_set_cmd_vel(position2d, 0.1, 0, 0.1, 1);
							}else{
								if (laser->scan[10][0] < dir){
									playerc_position2d_set_cmd_vel(position2d, 0.1, 0, 0.1, 1);
								}
								else{
									playerc_position2d_set_cmd_vel(position2d, 0.1, 0, -0.1, 1);
								}
							}
							playerc_client_read(client);
						}
						first = 0;
					}
					playerc_position2d_set_cmd_vel(position2d, 0.3, 0, 0, 1);
				} break;
				case 5: { //frente e esquerda
					if (first == 1){
						playerc_client_read(client);
						if(esq <= 2*dir)
						while (laser->scan[350][0] < 1.3*esq){
							//printf("laser: %f; 1.3*esq: %f\n", laser->scan[359][0], 1.3*esq);
							if (laser->scan[340][0] > laser->scan[350][0]){
								if (laser->scan[350][0] > esq)
									playerc_position2d_set_cmd_vel(position2d, 0.1, 0, 0.1, 1);
								else
									playerc_position2d_set_cmd_vel(position2d, 0.1, 0, -0.1, 1);
							}
							else{
								if (laser->scan[350][0] < esq){
									playerc_position2d_set_cmd_vel(position2d, 0.1, 0, -0.1, 1);
								}
								else{
									playerc_position2d_set_cmd_vel(position2d, 0.1, 0, 0.1, 1);
								}
							}
							playerc_client_read(client);
						}
						first = 0;
					}
					playerc_position2d_set_cmd_vel(position2d, 0.3, 0, 0, 1);
				} break;
				case 2: { //cruzamento
					if (first == 1){
						while (laser->scan[350][0] < 1.3*esq && laser->scan[360][0] != 8){
							if (laser->scan[340][0] > laser->scan[350][0]){
								if (laser->scan[350][0] > esq)
									playerc_position2d_set_cmd_vel(position2d, 0.1, 0, 0.1, 1);
								else
									playerc_position2d_set_cmd_vel(position2d, 0.1, 0, -0.1, 1);
							}
							else{
								if (laser->scan[350][0] < esq){
									playerc_position2d_set_cmd_vel(position2d, 0.1, 0, -0.1, 1);
								}
								else{
									playerc_position2d_set_cmd_vel(position2d, 0.1, 0, 0.1, 1);
								}
							}
							playerc_client_read(client);
						}
						first = 0;
					}
					playerc_position2d_set_cmd_vel(position2d, 0.3, 0, 0, 1);
				} break;
		    }
	    } break;
		case 1: { //virar para esquerda
			//printf("virar esq\n");
			playerc_client_read(client);

			if (first == 1){
				//saida do corredor ate o ponto de curva
	
						while (laser->scan[350][0] < 1.3*esq){
							//printf("laser: %f; 1.3*esq: %f\n", laser->scan[359][0], 1.3*esq);
							if (laser->scan[340][0] > laser->scan[350][0]){
								if (laser->scan[350][0] > esq)
									playerc_position2d_set_cmd_vel(position2d, 0.1, 0, 0.1, 1);
								else
									playerc_position2d_set_cmd_vel(position2d, 0.1, 0, -0.1, 1);
							}
							else{
								if (laser->scan[350][0] < 1.2*esq){
									playerc_position2d_set_cmd_vel(position2d, 0.1, 0, -0.1, 1);
								}
								else{
									playerc_position2d_set_cmd_vel(position2d, 0.1, 0, 0.1, 1);
								}
							}
							playerc_client_read(client);
						}
						first = 0;
			}
			playerc_position2d_set_cmd_vel(position2d, 0.45, 0, 0.35, 1);
		} break;
		case 2: { //virar para direita
			//printf("virar dir\n");
			playerc_client_read(client);

			if (first == 1){	
				//printf("laser10: %f; 1.3*dir: %f\n", laser->scan[10][0], 1.3*dir);
				while (laser->scan[10][0] < 1.3*dir){
					if (laser->scan[20][0] > laser->scan[10][0]){
						if (laser->scan[10][0] > dir)
							playerc_position2d_set_cmd_vel(position2d, 0.1, 0, -0.1, 1);
						else
							playerc_position2d_set_cmd_vel(position2d, 0.1, 0, 0.1, 1);
					}else{
						if (laser->scan[10][0] < 1.2*dir){
							playerc_position2d_set_cmd_vel(position2d, 0.1, 0, 0.1, 1);
							//printf("la\n");
						}
						else{
							playerc_position2d_set_cmd_vel(position2d, 0.1, 0, -0.1, 1);
							//printf("le\n");
						}
					}
					playerc_client_read(client);
					//printf("laser10: %f; 1.3*dir: %f\n", laser->scan[10][0], 1.3*dir);
				}
				first = 0;
			}
			playerc_position2d_set_cmd_vel(position2d, 0.45, 0, -0.35, 1);
		} break;
		case 3: { //dar meia volta
			//printf("volta\n"); darMeiaVolta(client, laser, position2d, acoes[i], 1);
		} break;
		case 4: { //alinhar corredor
			//printf("corredor\n");
		        playerc_client_read(client);
			//playerc_position2d_set_cmd_vel(position2d, 0.3, 0, -0.0, 1);

			if(first == 1){
                            esq = laser->scan[359][0];
                            first = 0;
			}

			if (laser->scan[348][0] > laser->scan[350][0]){
				if (laser->scan[350][0] > 1.2*esq){
					playerc_position2d_set_cmd_vel(position2d, 0.1, 0, 0.1, 1);
				}
				else{
					playerc_position2d_set_cmd_vel(position2d, 0.1, 0, -0.1, 1);
				}
			}
			else{
				if (laser->scan[350][0] < 1.2*esq){
					playerc_position2d_set_cmd_vel(position2d, 0.1, 0, -0.1, 1);
				}
				else{
					playerc_position2d_set_cmd_vel(position2d, 0.1, 0, 0.1, 1);
				}
			}

		} break;
	}
	}

	playerc_position2d_unsubscribe(position2d);
	playerc_position2d_destroy(position2d);
	playerc_client_disconnect(client);
	playerc_client_destroy(client);
	return 0;
}


